Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12098)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12099)
@@ -1117,7 +1117,7 @@
 
     @property
-    def selectable_apptypes(self):
-        apptypes = getUtility(ICustomersUtils).SELECTABLE_APPTYPES_DICT
-        return sorted(apptypes.items())
+    def selectable_contypes(self):
+        contypes = getUtility(ICustomersUtils).SELECTABLE_CONTYPES_DICT
+        return sorted(contypes.items())
 
     @action(_('Create contract'), style='primary')
@@ -1130,5 +1130,5 @@
         contract = createObject('waeup.%s' % apptype)
         self.context.addContract(contract)
-        apptype = getUtility(ICustomersUtils).SELECTABLE_APPTYPES_DICT[apptype]
+        apptype = getUtility(ICustomersUtils).SELECTABLE_CONTYPES_DICT[apptype]
         self.flash(_('${a} created.',
             mapping = {'a': apptype}))
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/contractaddform.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/contractaddform.pt	(revision 12098)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/contractaddform.pt	(revision 12099)
@@ -10,7 +10,7 @@
           <select id="apptype" name="apptype" size="1"
                   class="form-control half">
-            <option tal:repeat="item view/selectable_apptypes"
+            <option tal:repeat="item view/selectable_contypes"
                     tal:attributes="value python:item[0]">
-              <span tal:replace="python:item[1]">APPTYPE</span>
+              <span tal:replace="python:item[1]">CONTYPE</span>
             </option>
           </select>
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12098)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12099)
@@ -119,8 +119,8 @@
             # Customer must be approved
             cond1 = self.customer.state in getUtility(
-                ICustomersUtils).APPMANAGE_CUSTOMER_STATES
+                ICustomersUtils).CONMANAGE_CUSTOMER_STATES
             # Contract must be in state created
             cond2 = self.state in getUtility(
-                ICustomersUtils).APPMANAGE_CONTRACT_STATES
+                ICustomersUtils).CONMANAGE_CONTRACT_STATES
             if not (cond1 and cond2):
                 return False
@@ -132,6 +132,6 @@
     def translated_class_name(self):
         try:
-            APPTYPES_DICT = getUtility(ICustomersUtils).APPTYPES_DICT
-            return APPTYPES_DICT[self.class_name]
+            CONTYPES_DICT = getUtility(ICustomersUtils).CONTYPES_DICT
+            return CONTYPES_DICT[self.class_name]
         except KeyError:
             return
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12098)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/utils.py	(revision 12099)
@@ -287,7 +287,7 @@
     DOCMANAGE_DOCUMENT_STATES = (CREATED,)
 
-    APPMANAGE_CUSTOMER_STATES = DOCMANAGE_CUSTOMER_STATES
-
-    APPMANAGE_CONTRACT_STATES = (CREATED,)
+    CONMANAGE_CUSTOMER_STATES = DOCMANAGE_CUSTOMER_STATES
+
+    CONMANAGE_CONTRACT_STATES = (CREATED,)
 
     SKIP_UPLOAD_VIEWLETS = ()
@@ -314,5 +314,5 @@
         }
 
-    APPTYPES_DICT = {
+    CONTYPES_DICT = {
         'SampleContract': 'Sample Contract',
         }
@@ -320,5 +320,5 @@
     SELECTABLE_DOCTYPES_DICT = DOCTYPES_DICT
 
-    SELECTABLE_APPTYPES_DICT = APPTYPES_DICT
+    SELECTABLE_CONTYPES_DICT = CONTYPES_DICT
 
     def getPDFCreator(self, context=None):