Index: main/waeup.kwarapoly/trunk/CHANGES.txt
===================================================================
--- main/waeup.kwarapoly/trunk/CHANGES.txt	(revision 12147)
+++ main/waeup.kwarapoly/trunk/CHANGES.txt	(revision 12148)
@@ -4,4 +4,6 @@
 1.2dev (unreleased)
 ===================
+
+* Maint payment checking disabled on Dec 5th, 2014.
 
 * Nationality and sex must be edited by pre-admission applicants.
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py	(revision 12147)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py	(revision 12148)
@@ -80,6 +80,6 @@
         notify(grok.ObjectModifiedEvent(self.student))
 
-
-    def test_schoolfee_ticket_creation(self):
+    # Maint payment checking disabled on 5th Dec 2014
+    def xx_test_schoolfee_ticket_creation(self):
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
         self.browser.open(self.payments_path)
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 12147)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 12148)
@@ -104,11 +104,13 @@
         IWorkflowState(self.student).setState('cleared')
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
-        self.browser.getControl("Create ticket").click()
-        self.assertMatches('...Book and pay for accommodation first...',
-                           self.browser.contents)
-
-        # In KwaraPoly only returning students can create school fee payment
-        # without having paid accommodation fee
+
+        # Maint payment checking disabled on 5th Dec 2014
+        #self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        #self.browser.getControl("Create ticket").click()
+        #self.assertMatches('...Book and pay for accommodation first...',
+        #                   self.browser.contents)
+        ## In KwaraPoly only returning students can create school fee payment
+        ## without having paid accommodation fee
+
         IWorkflowState(self.student).setState('returning')
         configuration = createObject('waeup.SessionConfiguration')
@@ -220,14 +222,16 @@
         self.assertEqual(pt_ft(self.student), 'ft')
 
-        error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(error,
-            'Book and pay for accommodation first before making'
-            ' school fee payments.')
-        # We add a fake maint. payment ticket to meet the condition
-        maint_payment = createObject('waeup.StudentOnlinePayment')
-        self.student['payments']['any_key'] = maint_payment
-        maint_payment.p_category = 'hostel_maintenance'
-        maint_payment.p_state = 'paid'
-        maint_payment.p_session = 2004
+        # Maint payment checking disabled on 5th Dec 2014
+        #error, payment = utils.setPaymentDetails('schoolfee',self.student)
+        #self.assertEqual(error,
+        #    'Book and pay for accommodation first before making'
+        #    ' school fee payments.')
+        ## We add a fake maint. payment ticket to meet the condition
+        #maint_payment = createObject('waeup.StudentOnlinePayment')
+        #self.student['payments']['any_key'] = maint_payment
+        #maint_payment.p_category = 'hostel_maintenance'
+        #maint_payment.p_state = 'paid'
+        #maint_payment.p_session = 2004
+
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
         self.assertEqual(payment.p_level, 100)
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 12147)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 12148)
@@ -131,10 +131,14 @@
 
     def _maintPaymentMade(self, student, session):
-        if len(student['payments']):
-            for ticket in student['payments'].values():
-                if ticket.p_category == 'hostel_maintenance' and \
-                    ticket.p_session == session and ticket.p_state == 'paid':
-                        return True
-        return False
+
+        # Maint payment checking disabled on 5th Dec 2014
+        return True
+
+        #if len(student['payments']):
+        #    for ticket in student['payments'].values():
+        #        if ticket.p_category == 'hostel_maintenance' and \
+        #            ticket.p_session == session and ticket.p_state == 'paid':
+        #                return True
+        #return False
 
     def _bedAvailable(self, student):